<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >
  <xsl:template match="/">
    <xsl:text disable-output-escaping="yes"><![CDATA[
<!DOCTYPE web-app
    PUBLIC "-//Sun Microsystems, Inc.//DTD Web Application 2.3//EN"
        "http://java.sun.com/dtd/web-app_2_3.dtd">
    ]]></xsl:text><web-app>
      <servlet>
        <servlet-name>CewolfServlet</servlet-name>
        <servlet-class>de.laures.cewolf.CewolfRenderer</servlet-class>
        <!-- sets storage implementation -->
        <init-param>
            <param-name>storage</param-name>
            <param-value>de.laures.cewolf.storage.TransientSessionStorage</param-value>
        </init-param>
        <!-- sets overlib.js location relative to webapp -->
        <init-param>
            <param-name>overliburl</param-name>
            <param-value>js/overlib.js</param-value>
        </init-param>
        <!-- turn on or off debugging logging -->
        <init-param>
            <param-name>debug</param-name>
            <param-value>true</param-value>
        </init-param>
        <load-on-startup>1</load-on-startup>
      </servlet>
      <xsl:for-each select="web-app/servlet">
        <servlet>
          <servlet-name><xsl:value-of select="servlet-name"/></servlet-name>
          <servlet-class><xsl:value-of select="servlet-class"/></servlet-class>
        </servlet>
      </xsl:for-each>
      <servlet-mapping>
        <servlet-name>CewolfServlet</servlet-name>
        <url-pattern>/cewolf/*</url-pattern>
      </servlet-mapping>
      <xsl:for-each select="web-app/servlet-mapping">
        <servlet-mapping>
          <servlet-name><xsl:value-of select="servlet-name"/></servlet-name>
          <url-pattern><xsl:value-of select="url-pattern"/></url-pattern>
        </servlet-mapping>
      </xsl:for-each>
    </web-app>
  </xsl:template>
</xsl:stylesheet>
