<%@ page import="edu.sdsc.inca.consumer.dataproducer.*" %>
<%@ page import="edu.sdsc.inca.util.StringMethods"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.Calendar"%>
<%@ page import="java.util.Iterator"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@page contentType="text/html"%>
<%@taglib uri='cewolf.tld' prefix='cewolf' %>
<%@taglib uri='inca.tld' prefix='inca' %>

<html>
<head>
  <link href="css/inca.css" rel="stylesheet" type="text/css"/>
  <script language="javascript" src="js/graph.js"></script>
</head>
<body>
<%
  try {
  String testName = request.getParameter("testName");
  String resourceName = request.getParameter("resourceName");
  if (testName == null || testName.equals("") ||
      resourceName == null || resourceName.equals("")) {
    out.println("This script requires \"testName\" " +
        "and \"resourceName\" parameters.");
  }else{
    String seriesLabel = request.getParameter("seriesLabel");
    if (seriesLabel == null || seriesLabel.equals("")) {seriesLabel = testName;}
    String[] testNames = testName.split(",");
    String[] resourceNames = resourceName.split(",");
    String[] seriesLabels = seriesLabel.split(",");
    pageContext.setAttribute("labels", seriesLabels);
    int numTests = testNames.length;
    if ((numTests != seriesLabels.length)&&(numTests != resourceNames.length)){
      out.println( "Must pass same number of testNames, resourceNames, " +
          "and seriesLabels");
    }else{
      String title = request.getParameter("title");
      if (title==null){ title = "Status History"; }

      String alias = request.getParameter("alias");
      if (alias==null){ alias = "false"; }
      boolean Alias = new Boolean(alias).booleanValue();

      String legend = request.getParameter("legend");
      if (legend==null){ legend = "false"; }
      boolean Legend = new Boolean(legend).booleanValue();

      String legendAnchor = request.getParameter("legendAnchor");
      if (legendAnchor==null){ legendAnchor = "south"; }

      String height = request.getParameter("height");
      if (height==null){ height = "300"; }
      int Height = new Integer(height).intValue();

      String width = request.getParameter("width");
      if (width==null){ width = "500"; }
      int Width = new Integer(width).intValue();

      String mime = request.getParameter("mime");
      if (mime==null){ mime = "image/png"; }

      String xaxislabel = request.getParameter("xaxislabel");
      if (xaxislabel==null){ xaxislabel= "reporter executed"; }
      String xmin = request.getParameter("xmin");
      String xmax = request.getParameter("xmax");
      String dateformat = "MMddyy";
      Date startDate = StringMethods.convertDateString(xmin, dateformat);
      Date endDate = StringMethods.convertDateString(xmax, dateformat);
      // set startDate to be two weeks ago if start param used
      String start = request.getParameter("start");
      if (start!=null){
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.DATE, -14);
        startDate = calendar.getTime();
        xmin = new SimpleDateFormat(dateformat).format(startDate);
      }

      String yaxislabel = request.getParameter("yaxislabel");
      if (yaxislabel==null){ yaxislabel= "result: pass = 1, fail = 0"; }
      String ymin = request.getParameter("ymin");
      if (ymin==null){ ymin= "-.1"; }
      String ymax = request.getParameter("ymax");
      if (ymax==null){ ymax= "1.1"; }
      String ytick = request.getParameter("ytick");
      if (ytick==null){ ytick= "1"; }

      String bgcolor = request.getParameter("bgcolor");
      if (bgcolor==null || bgcolor.equals("")){ bgcolor= "#AAAAFF"; }

      String map = request.getParameter("map");
      if (map==null){ map = "false"; }

      GraphInstanceHash hash = new GraphInstanceHash(testNames, resourceNames,
          startDate, endDate);
      pageContext.setAttribute("instances", hash);
      pageContext.setAttribute( "tsPostprocess", new TimeSeriesPostProcess() );
      pageContext.setAttribute
        ("combinedPostprocess", new CombinedChartPostProcess());
      pageContext.setAttribute("catPostprocess", new CategoryPostProcess() );
%>
<inca:timeSeries data="instances" labels="labels" var="data"/>
<inca:errorDist data="instances" labels="labels" var="errorDist"/>

<table cellpadding="10">
<tr valign="top"><td>
  <%
    if ( testNames.length > 1 ) {
  %>
  <cewolf:combinedchart layout="vertical"
                        type="combinedxy"
                        id="ts"
                        title="<%=title%>"
                        antialias="<%=Alias%>"
                        showlegend="<%=Legend%>"
                        legendanchor="<%=legendAnchor%>"
                        xaxislabel="<%=xaxislabel%>">
    <cewolf:colorpaint color="<%=bgcolor%>"/>
    <inca:forTimeSeries yaxisLabel="<%=yaxislabel%>"
                        yaxisLabelVar="yaxisLabel" var="timeSeriesI"
                        data="instances" labels="labels">
      <cewolf:plot type="xyline"
                   yaxislabel="<%=(String)pageContext.getAttribute("yaxisLabel")%>">
        <cewolf:data>
          <cewolf:producer id="timeSeriesI" />
        </cewolf:data>
        <cewolf:chartpostprocessor id="combinedPostprocess">
          <cewolf:param name="xmin" value="<%=xmin%>"/>
          <cewolf:param name="xmax" value="<%=xmax%>"/>
          <cewolf:param name="ymin" value="<%=ymin%>"/>
          <cewolf:param name="ymax" value="<%=ymax%>"/>
          <cewolf:param name="ytick" value="<%=ytick%>"/>
        </cewolf:chartpostprocessor>
      </cewolf:plot>
    </inca:forTimeSeries>
  </cewolf:combinedchart>
  <cewolf:img
    chartid="ts"
    renderer="/cewolf"
    width="<%=Width%>"
    height="<%=Height%>"
    mime="<%=mime%>">
  </cewolf:img>
  <% } else { %>
<cewolf:chart
    id="ts"
    type="timeseries"
    title="<%=title%>"
    antialias="<%=Alias%>"
    showlegend="<%=Legend%>"
    legendanchor="<%=legendAnchor%>"
    xaxislabel="<%=xaxislabel%>"
    yaxislabel="<%=yaxislabel%>">
  <cewolf:colorpaint color="<%=bgcolor%>"/>
  <cewolf:data>
    <cewolf:producer id="data"/>
  </cewolf:data>
  <cewolf:chartpostprocessor id="tsPostprocess">
    <cewolf:param name="xmin" value="<%=xmin%>"/>
    <cewolf:param name="xmax" value="<%=xmax%>"/>
    <cewolf:param name="ymin" value="<%=ymin%>"/>
    <cewolf:param name="ymax" value="<%=ymax%>"/>
    <cewolf:param name="ytick" value="<%=ytick%>"/>
  </cewolf:chartpostprocessor>
</cewolf:chart>
<cewolf:img
    chartid="ts"
    renderer="/cewolf"
    width="<%=Width%>"
    height="<%=Height%>"
    mime="<%=mime%>">
  <% if (map!=null && map.equals("true")){ %>
  <cewolf:map linkgeneratorid="data" tooltipgeneratorid="data"/>
  <%}%>
</cewolf:img>
  <% } %>
<br/><br/>
<table class="header"><tr>
  <td class="header">Executed on (report nickname)</td>
  <td class="header"># Total Reports</td>
  <td class="header"># Failed Reports</td>
  <td class="header"># Passed Reports</td>
  <td class="header">% Passed Reports</td>
</tr>
  <%
    TimeSeriesData data = (TimeSeriesData)pageContext.getAttribute("data");
    for(int i = 0; i < seriesLabels.length; i++){
      int fail = data.getseriesTotalFail()[i];
      int pass = data.getseriesTotalPass()[i];
      int total = fail + pass;
      out.println( "<tr><td class=\"clear\">" + seriesLabels[i] +
          "</td><td class=\"clear\">" + total +
          "</td><td class=\"clear\">" + fail +
          "</td><td class=\"clear\">" + pass +
          "</td><td class=\"clear\">" + data.getSeriesPercPass()[i] +
          "</td></tr>");
    }
  %> </table>
  </td><td>
  <h1>Customize Graph</h1>
  <form method="get" action="graph.jsp" name="graph"
        onsubmit="return validate(graph);">
    <table class="subheader">
      <% if ( testNames.length <= 1 ) {  %>
      <tr>
        <td>show mouseovers/hyperlinks for datapoints:</td>
        <td><input name="map" type="radio" value="true"/> yes
          <input name="map" type="radio" value="false" checked=""/> no</td>
      </tr>
      <% } %>
      <tr>
        <td>show legend:</td>
        <td><input name="legend" type="radio" value="true" checked=""/> yes
          <input name="legend" type="radio" value="false"/> no</td>
      </tr>
      <tr>
        <td>legend position:</td>
        <td>
          <input name="legendAnchor" type="radio"
                 value="south" checked=""/> south
          <input name="legendAnchor" type="radio" value="north"/> north
          <input name="legendAnchor" type="radio" value="east"/> east
          <input name="legendAnchor" type="radio" value="west"/> west
        </td>
      </tr>
      <tr>
        <td>width:</td>
        <td><input name="width" type="text" size="5" value="<%=Width%>"/></td>
      </tr>
      <tr>
        <td>height:</td>
        <td><input name="height" type="text" size="5" value="<%=Height%>"/></td>
      </tr>
      <tr>
        <td>background color:</td>
        <td><input name="bgcolor" type="text"
                   value="<%=bgcolor%>"/> (e.g. #DDDDDD)</td>
      </tr>
      <tr>
        <td>* start date:</td>
        <td><input name="xmin" type="text"
                   value="<%=xmin%>"/> (MMddyy format, e.g. "093007")</td>
      </tr>
      <tr>
        <td>end date:</td>
        <td><input name="xmax" type="text"
                   value="<%=xmax%>"/> (MMddyy format, e.g. "103007")</td>
      </tr>
      <% for(int i = 0; i < numTests; i++){ %>
      <tr>
        <td><%=seriesLabels[i]%></td>
        <td>
          <input type="checkbox" name="series"
                 value="<%=testNames[i]%>,<%=resourceNames[i]%>,<%=seriesLabels[i]%>"
                 checked=""/>
        </td>
      </tr>
      <%}%>
      <tr>
        <td>
          <input type="button" name="CheckAll" value="check all"
                 onClick="checkAll(graph.series)"/>
          <input type="button" name="UnCheckAll" value="uncheck all"
                 onClick="uncheckAll(graph.series)"/>
        </td>
      </tr>
    </table>
    <p>* Two weeks of data is graphed by default.
      Clear the "start date" value and click "re-graph" to plot all data.</p>
    <br/>
    <input type="hidden" name="series" value=""/>
    <input type="hidden" name="testName" value="<%=testName%>"/>
    <input type="hidden" name="resourceName" value="<%=resourceName%>"/>
    <input type="hidden" name="seriesLabel" value="<%=seriesLabel%>"/>
    <input type="submit" name="submit" value="re-graph"/>
  </form>
</td><tr valign="top"><td>
<%
  ErrorDistributionData errorDist =
    (ErrorDistributionData)pageContext.getAttribute("errorDist");
  if ( errorDist.getErrorTypes().length > 0 ) {
%>
<br/><br/>
<cewolf:chart
    id="hist"
    type="stackedverticalbar"
    title="Error Message Distribution"
    antialias="<%=Alias%>"
    showlegend="<%=Legend%>"
    legendanchor="<%=legendAnchor%>"
    xaxislabel="Error Type"
    yaxislabel="Error Count">
  <cewolf:colorpaint color="<%=bgcolor%>"/>
  <cewolf:data>
    <cewolf:producer id="errorDist"/>
  </cewolf:data>
  <cewolf:chartpostprocessor id="catPostprocess"/>
</cewolf:chart>
<cewolf:img
    chartid="hist"
    renderer="/cewolf"
    width="<%=Width%>"
    height="<%=Height%>"
    mime="<%=mime%>">
  <cewolf:map tooltipgeneratorid="errorDist"/>
</cewolf:img>
</td><td>
<br/><br/>
  <%
    errorDist.printCountsInTable
      ( out, data.getseriesTotalFail(), data.getseriesTotalPass() );
    }
  %>
</td></tr>
</table><br/>
<%}}
} catch ( Exception e ) {
  out.println( "Error occured in page: " + e );
  e.printStackTrace( System.err );  
}
%>
</body>
</html>
