<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<%@ taglib uri="inca.tld" prefix="i" %>
<%@ taglib uri="xslt.tld" prefix="xslt" %>
<%@ taglib uri="c.tld" prefix="c" %>
<%@page import="java.net.URL"%>

<%-- ------------------------------------------------------------------- --%>
<%-- Page for managing stored queries in the Consumer.  Queries can be   --%>
<%-- added, deleted, changed, or executed (and return XML).  This jsp    --%>
<%-- page manages the query manipulation via jsp tags and leaves the     --%>
<%-- display of the current queries to a stylesheet.                     --%>
<%--                                                                     --%>
<%-- Main input parameters:                                              --%>
<%--   action - Specifies one of the action to take on the query         --%>
<%--            (see below for more information)                         --%>
<%--   xsl - A stylesheet to apply to the query store XML that should    --%>
<%--             display the queries and manipulation options (if not    --%>
<%--             specified, query.xsl will be assumed).                  --%>
<%--                                                                     --%>
<%-- Actions:                                                            --%>
<%--   Add - add a query to the Consumer query store                     --%>
<%--     Required params:                                                --%>
<%--       - hql: A string containing an hql query                       --%>
<%--       - name: A string containing the name of the query             --%>
<%--     Optional params:                                                --%>
<%--       - period: An integer containing the frequency of fetches      --%>
<%--                 from thedepot (seconds) or 0 for no prefetching.    --%>
<%--                                                                     --%>
<%--   Change - change the details of a query                            --%>
<%--     Required params:                                                --%>
<%--       - hql:  A string containing an hql query                      --%>
<%--       - name:  A string containing the name of the query            --%>
<%--     Optional params:                                                --%>
<%--       - period: An integer containing the frequency of fetches      --%>
<%--                 from the depot (secs) or 0 for no prefetching.      --%>
<%--                                                                     --%>
<%--    Delete - delete a query from the Consumer query store            --%>
<%--      Required params:                                               --%>
<%--        - name: A string containing the name of the query to delete  --%>
<%--                                                                     --%>
<%--    Execute - execute a stored query and return the results in XML   --%>
<%--      Required params:                                               --%>
<%--        - name: A string containing the name of the query to execute --%>
<%--                                                                     --%>
<%--    Execute hql - execute a hql query and return the results in XML  --%>
<%--      Required params:                                               --%>
<%--        - hql:  A string containing an hql query                     --%>
<%--                                                                     --%>
<%-- ------------------------------------------------------------------- --%>

<html>
<head><title>Inca Query Page</title></head>
<body>
<%-- ------------------------------------------------------------------- --%>
<%-- Verify xsl parameter.                                               --%>
<%-- ------------------------------------------------------------------- --%>
<%
  String xsl = request.getParameter("xsl");
  if ( xsl == null ) xsl = "query.xsl";
  URL url = ClassLoader.getSystemClassLoader().getResource( xsl );
  if( url == null ) {
    out.println( "Unable to locate xsl file: " + xsl );
    return;
  }
  xsl = url.getFile();
%>
<c:set var='action' value='${param.action}'/>
<c:if test="${empty action}"><c:set var='action' value=''/></c:if>

<c:choose>
  <%-- ------------------------------------------------------------------- --%>
  <%-- Service a straight hql request for the depot                        --%>
  <%-- ------------------------------------------------------------------- --%>
  <c:when test="${param.action=='Execute hql'}">
    <i:queryHQL var="queryResult" hql='<%= request.getParameter("hql") %>'/>
    <pre>
      <i:printXML xml='<%=(String)pageContext.getAttribute("queryResult")%>'/>
    </pre>
  </c:when>
  <%-- ------------------------------------------------------------------- --%>
  <%-- Service a stored query request                                      --%>
  <%-- ------------------------------------------------------------------- --%>
  <c:when test="${param.action=='Execute'}">
    <i:queryHQL var="queryResult" name='<%= request.getParameter("qname") %>'/>
    <pre>
      <i:printXML xml='<%=(String)pageContext.getAttribute("queryResult")%>'/>
    </pre>
  </c:when>
  <%-- ------------------------------------------------------------------- --%>
  <%-- Service an Add, Change, or Delete, and/or display queries and       --%>
  <%-- manipulation options                                                --%>
  <%-- ------------------------------------------------------------------- --%>
  <c:otherwise>
    <c:choose>
      <c:when test="${param.action=='Add'}">
        <c:set var="resultType" value="add"/>
        <c:set var="resultTarget" value="${param.qname}"/>
        <i:addQuery var="result" hql='<%= request.getParameter("hql") %>'
                    name='<%= request.getParameter("qname") %>'
                    period='<%= request.getParameter("period") %>' />
      </c:when>
      <c:when test="${param.action=='Change'}">
        <c:set var="resultType" value="chang"/>
        <c:set var="resultTarget" value="${param.selectQname}"/>
        <i:changeQuery var="result"
                       hql='<%= request.getParameter("hql") %>'
                       oldName='<%= request.getParameter("selectQname") %>'
                       newName='<%= request.getParameter("qname") %>'
                       period='<%= request.getParameter("period") %>' />
      </c:when>
      <c:when test="${param.action=='Delete'}">
        <c:set var="resultType" value="delet"/>
        <c:set var="resultTarget" value="${param.qname}"/>
        <i:deleteQuery var="result"
                       name='<%= request.getParameter("selectQname") %>' />
      </c:when>
      <c:otherwise>
        <c:set var="result" value=""/>
      </c:otherwise>
    </c:choose>
    <%-- Display forms using xsl --%>
    <i:listQueries var="queryXml"/>
    <i:getDbSchema var="dbSchema"/>
    <%
      String xml = "<queryInfo>\n";
      xml += pageContext.getAttribute( "queryXml" );
      xml += pageContext.getAttribute( "dbSchema");
      xml += "</queryInfo>\n";
    %>
    <c:choose>
      <c:when test="${! empty param.debug}">
        <pre><i:printXML xml="<%=xml%>"/></pre>
      </c:when>
      <c:otherwise>
        <xslt:applyXSL xmlString='<%=xml%>' xslData='<%=xsl%>'>
          <xslt:setParameter name="qname">
            <c:out value="${param.qname}"/></xslt:setParameter>
          <xslt:setParameter name="hql">
            <c:out value="${param.hql}"/></xslt:setParameter>
          <xslt:setParameter name="period">
            <c:out value="${param.period}"/> </xslt:setParameter>
        </xslt:applyXSL>
      </c:otherwise>
    </c:choose>
  </c:otherwise>
</c:choose>

</body>
</html>
