<%@ page import="edu.sdsc.inca.consumer.dataproducer.ErrorDistributionData" %>
<%@ page import="edu.sdsc.inca.consumer.dataproducer.GraphInstanceHash" %>
<%@ page import="edu.sdsc.inca.consumer.dataproducer.TimeSeriesData" %>
<%@ page import="edu.sdsc.inca.consumer.dataproducer.CombinedChartPostProcess" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.util.Date" %>
<%@ page import="java.text.DateFormat" %>
<%@ page import="edu.sdsc.inca.consumer.StatusReport" %>
<%@ page import="edu.sdsc.inca.consumer.dataproducer.CategoryPostProcess" %>
<%@ page import="edu.sdsc.inca.ConfigurationException" %>
<%@taglib uri='inca.tld' prefix='inca' %>
<%@taglib uri='cewolf.tld' prefix='cewolf' %>
<%@ taglib uri="c.tld" prefix="c" %>

<%-- --------------------------------------------------------------------- --%>
<%-- Outputs groups of graphs.  Each graph row can contain the results of  --%>
<%-- any number of series and displays the results in a time series graph  --%>
<%-- showingthe exit status of a series, a bar graph showing the number of --%>
<%-- errors found, and a table showing the error messages.                 --%>
<%-- --------------------------------------------------------------------- --%>
<title>Inca Graph Page</title>
<head>
  <link href="css/inca.css" rel="stylesheet" type="text/css"/>
  <script language="javascript" src="js/graph.js"></script>
</head>
<body>

<%
  try {
    // globals
    String TIMESERIES_YTICK = "1";
    String TIMESERIES_YMAX = "1.1";
    String TIMESERIES_YMIN = "-0.1";
    String ERRORDIST_YTICK = "1";
    String TIMESERIES_YAXIS_LABEL = "Result:  pass = 1, fail = 0";
    String MIME = "image/png";

    // parse date strings
    String startDateString  = request.getParameter("startDate");
    Date startDate = null, endDate = null;
    if ( startDateString != null ) {
      startDate = new SimpleDateFormat("MMddyy").parse(startDateString);
    }
    String endDateString = request.getParameter("endDate");
    if ( endDateString != null ) {
      endDate = new SimpleDateFormat("MMddyy").parse(endDateString);
    }

    // read data from xml
    String xmlFile = request.getParameter("xmlFile");
    if ( xmlFile == null ) {
      xmlFile = "statusReport.xml";
    }
%>
<inca:getXmlFromClasspath var="xml" xmlFile="<%=xmlFile%>"/>  
<%
    StatusReport graphs =
      new StatusReport( (String)pageContext.getAttribute("xml") );
    pageContext.setAttribute( "graphDesc", graphs );
    int WIDTH = graphs.getWidth();
    int HEIGHT = graphs.getHeight();

    // set processor
    CombinedChartPostProcess postprocess = new CombinedChartPostProcess();
    pageContext.setAttribute("timeSeriesPostprocess", postprocess);
    CategoryPostProcess cPostprocess = new CategoryPostProcess();
    pageContext.setAttribute("categoryPostprocess", cPostprocess);
    pageContext.setAttribute( "graphCount", "" + graphs.getGraphCount() );
%>
<h1 class="body">
  <%
    DateFormat df = new SimpleDateFormat("MMM d, yyyy");
    if ( startDate != null && endDate != null ) {
      out.print
        ( "Results for " + df.format(startDate) + " to " + df.format(endDate) );
    } else if ( startDate == null && endDate == null ) {
      out.print( "Complete result history" );
    } else if ( startDate == null ) {
      out.print( "Results from start to " + df.format(endDate) );
    } else if ( endDate == null ) {
      out.print( "Results from " + df.format(startDate) + " to now" );
    }
  %>
</h1>
<table>
  <c:forEach begin="0" end="${graphCount-1}" var="i">
    <%
      int i = ((Integer)pageContext.getAttribute( "i" )).intValue();
      String[] seriesLabels = graphs.getSeriesLabels(i);
      pageContext.setAttribute("labels", seriesLabels);      
      GraphInstanceHash instances = new GraphInstanceHash
        ( graphs.getSeriesNicknames(i), graphs.getSeriesResources(i),
          startDate, endDate);
      pageContext.setAttribute("instances", instances);
    %>
    <inca:timeSeries data="instances" labels="labels" var="timeSeries"/>
    <inca:errorDist data="instances" labels="labels" var="errorDist"/>
    <tr><td colspan="3" class="header">
      <%=graphs.getSeriesTitle(i)%>
    </td></tr>
    <tr>
      <td valign="top">
        <cewolf:combinedchart id="ts" layout="vertical"
                              title="Status History"
                              type="combinedxy"
                              xaxislabel="Test result collection time">
          <cewolf:colorpaint color="#AAAAFF"/>

          <inca:forTimeSeries yaxisLabel="<%=TIMESERIES_YAXIS_LABEL%>"
                              yaxisLabelVar="yaxisLabel" var="timeSeriesI"
                              data="instances" labels="labels">
            <cewolf:plot type="xyline"
              yaxislabel="<%=(String)pageContext.getAttribute("yaxisLabel")%>">
              <cewolf:data>
                <cewolf:producer id="timeSeriesI" />
              </cewolf:data>
              <cewolf:chartpostprocessor id="timeSeriesPostprocess">
                <cewolf:param name="xmin" value="<%=startDateString%>"/>
                <cewolf:param name="xmax" value="<%=endDateString%>"/>
                <cewolf:param name="ymin" value="<%=TIMESERIES_YMIN%>"/>
                <cewolf:param name="ymax" value="<%=TIMESERIES_YMAX%>"/>
                <cewolf:param name="ytick" value="<%=TIMESERIES_YTICK%>"/>
              </cewolf:chartpostprocessor>

            </cewolf:plot>
          </inca:forTimeSeries>

        </cewolf:combinedchart>
        <cewolf:img
          chartid="ts"
          renderer="/cewolf"
          width="<%=WIDTH%>"
          height="<%=HEIGHT%>"
          mime="<%=MIME%>">
        </cewolf:img>
      </td>
      <%
        TimeSeriesData tsData =
          (TimeSeriesData)pageContext.getAttribute("timeSeries");
        ErrorDistributionData errorDist =
          (ErrorDistributionData)pageContext.getAttribute("errorDist");
        if ( errorDist.getErrorTypes().length > 0 ) {
      %><td valign="top">
      <cewolf:chart
        id="hist"
        type="stackedverticalbar"
        title="Error Message Distribution"
        xaxislabel="Error Type"
        yaxislabel="Error Count">
        <cewolf:colorpaint color="#AAAAFF"/>
        <cewolf:data>
          <cewolf:producer id="errorDist" />
        </cewolf:data>
        <cewolf:chartpostprocessor id="categoryPostprocess"/>
      </cewolf:chart>
      <cewolf:img
        chartid="hist"
        renderer="/cewolf"
        width="<%=WIDTH%>"
        height="<%=HEIGHT%>"
        mime="<%=MIME%>">
        <cewolf:map tooltipgeneratorid="errorDist"/>
      </cewolf:img>
    </td><td valign="top">
      <%
        errorDist.printCountsInTable
          ( out, tsData.getseriesTotalFail(), tsData.getseriesTotalPass() );
      %>
    </td>
      <%
      } else {
      %>
      <td class="clear"><i>no errors</i></td>
      <td valign="top">
      <%
          tsData.printCountsInTable( out );
        }
      %>
      </td>
    </tr><tr><td class="clear" colspan="3"/></tr>
  </c:forEach>
</table>

<%
  } catch (Exception e ) {
    out.println( "Error occured in page: " + e );
    e.printStackTrace( System.err );
  }
%>

</body>
</html>
